/****************************************************************************\
*                                                                            *
*  THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE  *
*     WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR     *
*   PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.   *
*                                                                            *
*     In no event will the supplier be liable for any lost revenue           *
*   or profits or other special, indirect and consequential damages, even    *
*    if the supplier has been advised of the possibility of such damages.    *
*                                                                            *
*             Users may copy or modify this file without charge,             *
*       but are NOT authorized to license or sell it to anyone.              *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
*                                                                            *
*    If you modify this software, you should include a notice giving the     *
* name of the person performing the modification, the date of modification,  *
* and the reason for such modification.  Bug reports or fixes should be sent *
*        to the author, who may or may not act on them as he desires:        *
*                                                                            *
* Internet: raytrace@cutmcvax.cs.curtin.edu.au                               *
*                                                                            *
* Mail   : School of Computer Science         | Tel: 619 351 7680            *
*          Curtin University of Technology    | Fax: 619 351 2819            *
*          Kent Street, Bentley                                              *
*          Western Australia, 6102                                           *
*                                                                            *
\****************************************************************************/

/*
 Copyright (c) 1991 Andrew Marriott.
 */

#include <stdlib.h>
#include <stdio.h>
#include <forms.h>
#include "parameters.h"

#define FORM_WIDTH 1280.0
#define FORM_HEIGHT 1020.0
#define FORM_WINDOW_X 0
#define FORM_WINDOW_Y 0
#define FORM_TYPE FL_SHADOW_BOX
#define FORM_BASE_X 35L
#define FORM_BASE_Y 7L

#define BOX_WIDTH 300.0
#define BOX_HEIGHT 50.0
#define BOX_TYPE FL_UP_BOX

#define SLIDER_WIDTH 256.0
#define SLIDER_HEIGHT 20.0
#define SLIDER_PRECISION 2
#define SLIDER_TYPE FL_HOR_SLIDER
#define SLIDER_START_X 22

#define BUTTON_WIDTH_RESET 50.0
#define BUTTON_WIDTH_DISPLAY 80.0
#define BUTTON_HEIGHT 20.0
#define BUTTON_TYPE_RESET FL_NORMAL_BUTTON
#define BUTTON_TYPE_DISPLAY FL_PUSH_BUTTON
#define CONTROL_BUTTON_WIDTH (100.0-FIELD_GAP)
#define CONTROL_BUTTON_HEIGHT (25.0-FIELD_GAP)

#define TEXT_WIDTH 65.0
#define TEXT_HEIGHT 20.0
#define TEXT_TYPE FL_NORMAL_TEXT

#define INPUT_WIDTH 80.0
#define INPUT_HEIGHT 20.0
#define INPUT_TYPE FL_NORMAL_INPUT

#define BROWSER_WIDTH (600.0-20.0)
#define BROWSER_HEIGHT (10.0+14*BOX_HEIGHT)
#define BROWSER_WINDOW_X (10.0+BOX_WIDTH+FORM_BASE_X)
#define BROWSER_WINDOW_Y (10.0+FORM_BASE_Y+5*BOX_HEIGHT)

#define FIELD_GAP 2
#define EDGE_GAP 5
#define START_X 5
static FL_FORM *form;
static FL_FORM *browser;
static FL_FORM *animate_input;
static FL_OBJECT *exit_button;
static FL_OBJECT *wire_button;
static FL_OBJECT *dsave_button;
static FL_OBJECT *drestore_button;
static FL_OBJECT *psave_button;
static FL_OBJECT *prestore_button;
static FL_OBJECT *push_button;
static FL_OBJECT *help_button;
static FL_OBJECT *reset_all_button;
static FL_OBJECT *pop_button;
static FL_OBJECT *start_stop_button;
static FL_OBJECT *animate_button;
static FL_OBJECT *print_button;
static float animate_x,animate_y;

static FL_OBJECT *input_obj[MAX_PARAMETERS];
static FL_OBJECT *slider_obj[MAX_PARAMETERS];
int	form_window;

extern int object_is_visible[];
extern Parameter parameter[MAX_PARAMETERS];
       float     initial_parameters[MAX_PARAMETERS];
       float     final_parameters[MAX_PARAMETERS];
       int       parameters_which_changed[MAX_PARAMETERS];
       int       number_of_changed_parameters;

extern int forkflg;
extern int wire;
extern long bgc;
extern long face_window;
